% This is to test the use of chens method of solving for the connection
% coefficients


% The Wavelet Genus
N = 6;

% Get the daubechies coefficients
a = daub_coefficients(N);

% ap_bar is the same size as N but since a1=a-1 and a2=a-2 we only need to
% compute half
ap_bar = zeros(N,1);

% The index for our ap_bar
p_bar = 1;

% We need to calculate half of the ap_bar values because the other halves
% are just the same
for p=1:2:(N/2)
    
    % Find the r1 and r2 values
    r1 = max(0,p);
    r2 = min(N-1,(N-1+p));
    
    % Now loop over all the r values
    for r=r1:r2
        
        % Compute the running sum of ap_bar
        ap_bar(p_bar) = ap_bar(p_bar) + a(r+1).*a(r-p+1);
    end
    
    p_bar = p_bar + 1;
    
end


% Now we need to construct the A matrix

    % this is the same as the way we have been doing it



        
        