% This is to test the unsteady error

% we have64 elements
n =64;


% The Error
Err = zeros(size(n,1),1);


fprintf('\\begin{center}\n');
fprintf('\\begin{tabular}{| c | c | c |}\n');
fprintf('Basis functions & Euclidean Error \\\\\n');
fprintf('\\hline\n');


for i=1:10
    
    [urom,~,~,uwg] = POD_simulate(12,6,1/(2^12),.1,1,1.5,0,.75,'BASIS.txt',i,0);
    uwg = uwg(:,size(uwg,2));
    urom = urom(2:length(urom)-1);
    %uex = u_exact(
    Err(i,1) = norm(urom - uwg(2:64))./norm(uwg(2:64));
    
    % Calculate the euclidean error
    
    fprintf('%i & %7.5e \\\\\n',i,Err(i,1));
    
%     if(i==1)
%         fprintf('%f & %7.5e & %7.5e &  &  \\\\\n',h(i),Err(i,1),Err(i,2));
%     else
%         l2rate = log(Err(i-1,1)./Err(i,1))./log(h(i-1)./h(i));
%         eucrate = log(Err(i-1,2)./Err(i,2))./log(h(i-1)./h(i));
%         fprintf('%f & %e & %e & %d & %d \\\\\n',h(i),Err(i,1),Err(i,2),l2rate,eucrate);
%     end
%     
    %h = h./1.5;
end

% Plot'er
% figure(2)
% plot(h,Err);
% hold on
% xlabel('h value');
% ylabel('Error');
% hold off


