%% This function will evaluate our right hand side at
%% a given x vector
function [fx] = rhs(x,time)
	
	% These right hand sides are for a number of test
	% problems that I have used, Note you must change:
	% u_exact.m and geometry.m to acurately represent
	% the problem you are trying to solve
	
    % u_exact = sin(pi*x) with 
    %fx = 0;
    
	% u_exact = (sin(x)./sin(1))
	%fx = 2*(sin(x)./sin(1));
	
	% u_exact = x
	%fx = x;
	
	% u_exact = x.^2
	%fx = -2 + (x.^2);
	
	% u_exact = x.^3
	%fx = (-6*x) + (x.^3);
	
	% u_exact = x.^4
	%fx = -12*(x.^2) + (x.^4);
	
	% u_exact = x(x-1).^2
    % Note changed the code to include single derivative term
	% Single Deriv
    %fx = (x.^3) + (x.^2) + (-9*x) + 5;
    % No single deriv
    %fx = (x.^3) - (2*(x.^2)) + (-5*x) + 4;
    
    % u_exact = t(x(x-1).^2) % Time dependent problem
    % Note changed the code to include single derivative term
	%fx = (x.*((x-1).^2)) + (time.*((x.^3) + (x.^2) + (-9*x) + 5));
	%fx = ((8.*(x.^3)) - 4.*(17*(x.^2)) + 2.*(54*x) + 140);
    %fx = ((x.^3) - (17*(x.^2)) + (54*x) + 140);
    
    % u_exact = x(x-1)
    

    %fx = (x.^2) - (8*x) - 12;
    
	% u_exact = exp(x)
	fx = 0;
    
    
    %fx = (time + (time.*4.*pi.^2)+1).*sin(2.*pi.*x);
    
     fx = x.*(x-1).*(sin(50*x)+ 200*time.*cos(50*x)) ...
                - time.*(2*(sin(50*x)+100*time.*cos(50*x)) + 100*(x-1).*(cos(50.*x)-100*time.*sin(50*x)) + ...
                  100*x.*(cos(100*x)-100*time*sin(50*x)) + (50^2).*x.*(x-1).*(-sin(50*x)-100*time.*cos(50*x))) ...
                + time.*x.*(x-1).*(sin(50*x)+100*time.*cos(50*x));
    
   %fx = 0;
    

end